#
# spec file for package rubygem-pairing_heap
#
# Copyright (c) 2023 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


#
# This file was generated with a gem2rpm.yml and not just plain gem2rpm.
# All sections marked as MANUAL, license headers, summaries and descriptions
# can be maintained in that file. Please consult this file before editing any
# of those fields
#

Name:           rubygem-pairing_heap
Version:        3.0.1
Release:        1.1
%define mod_name pairing_heap
%define mod_full_name %{mod_name}-%{version}
BuildRequires:  %{ruby >= 2.3.0}
BuildRequires:  %{rubygem gem2rpm}
BuildRequires:  ruby-macros >= 5
URL:            https://github.com/mhib/pairing_heap
Source:         https://rubygems.org/gems/%{mod_full_name}.gem
Source1:        gem2rpm.yml
Summary:        Performant priority queue in pure ruby with support for changing
License:        MIT

%description
Performant priority queue in pure ruby with support for changing priority
using pairing heap data structure.

%prep

%build

%install
%gem_install \
  --doc-files="LICENSE.txt README.md" \
  -f
# MANUAL
# drop files from the git repository
find %{buildroot}/%{_libdir}/ruby/gems/ \( -name '.rubocop.yml' -o -name '.github' -o -name '.gitignore' \) | xargs rm -rf
# /MANUAL

%gem_packages

%changelog
* Fri Nov  3 2023 Dan Čermák <dan.cermak@posteo.net>
- 3.0.1:
  [#] Fixed issues
  * `change_priority` could sometimes return `nil` instead of `self`
  3.0.0:
  [#] Breaking changes
- `#pop` returns `nil` on empty heap instead of raising an Error
- `#get_priority` returns nil on empty heap instead of raising an Error
  [#] New methods
- `PairingHeap::PairingHeap#include?`
- `#each_with_priority`
  2.0.0:
  [#] Breaking changes
  * Second argument of #push now defaults to the first argument
  ```ruby
  [#] it is now possible to write
  array.each { |el| heap.push(el) }
  [#] instead of
  array.each { |el| heap.push(el, el) }
  ```
  * PairingHeap#pop_priority was separated to two methods; PairingHeap#pop_priority and PairingHeap#pop_with_priority, similarly to SimplePairingHeap
  [#] New methods
  * `#each` returns an iterator of heap elements.
  * `PairingHeap#get_priority_if_exists` returns a pair where first element is success flag, and second element is priority.
* Mon Oct 10 2022 Stephan Kulow <coolo@suse.com>
  updated to version 1.0.0
  no changelog found
* Tue Aug 30 2022 Dan Čermák <dcermak@suse.com>
- First version of the pairing_heap gem
